// generated by: arc -xuNP -A ./../argrt -M -o call.c -H call.h -m call.argl.tmp call.arg 
#ifndef _call_HEADER__device_2052_inode_4268265_
#define _call_HEADER__device_2052_inode_4268265_

typedef struct argile_call_t_s argile_call_t;
typedef enum   argile_call_type_t_e argile_call_type_t;
typedef struct argile_call_param_t_s argile_call_param_t;
typedef struct argile_call_list_t_s argile_call_list_t;

#include "./../argrt/std.h"
#include "./../argrt/array.h"
#include "./dbg.h"
#include "./argilectx.h"
#include "./type.h"
#include "./buff.h"
#include "call.h"
#include "./code.h"
#include "./cons.h"
#include "./def.h"
#include "./list.h"
#include "./loc.h"
#include "./match.h"
#include "./shovel.h"
#include "./syntax.h"
#include "./fnc.h"
#include "./field.h"
#include "./var.h"
#include "./inout.h"
#include "./module.h"
#include "./bind.h"

enum   argile_call_type_t_e {
  ARGILE_CALL_EXPLICIT,
  ARGILE_CALL_IMPLICIT
};

struct argile_call_t_s {
  argile_call_type_t type;
  argile_type_t context;
  argile_code_t * scope;
  argile_call_t * owner;
  argile_def_t * def;
  argile_list_t * match;
  argile_loc_t loc;
  unsigned char matched : 1;
  unsigned char rejected : 1;
  unsigned char compiled : 1;
  unsigned char stealth : 1;
  unsigned char autoparam : 1;
  unsigned char keep_data : 1;
  argile_list_t * rejects;
  unsigned int nrejects;
  unsigned int numcomp;
  unsigned int hit;
  short minmatch;
  short maxmatch;
  argile_list_t * pot_defs;
  void * data;
  argile_deleter_t del;
  argile_list_t * params;
  argile_list_t * options;
  argile_list_t * enums;
  argile_list_t * lists;
  argile_list_t *(* sigs);
  char * comment;
};

struct argile_call_param_t_s {
  argile_syn_param_t * syn_param;
  argile_list_t * matches;
  argile_def_t * def;
};

struct argile_call_list_t_s {
  argile_list_t * values;
  argile_list_t * params;
  argile_list_t * options;
  argile_list_t * enums;
  argile_list_t * lists;
};

argile_call_t * argile_call_new(argile_def_t *, argile_list_t *);
/** :argile_call_new <def> <list of (match) match>: -> (argile) call **/
void argile_call_del(argile_call_t *);
/** :argile_call_del <call>: -> nothing **/
int argile_call_eq(argile_call_t *, argile_call_t *);
/** :argile_call_eq <call ca> <call cb>: -> int **/
argile_call_t * argile_call_shadow(argile_call_t *);
/** :argile_call_shadow <call>: -> (argile) call **/
argile_call_param_t * argile_call_param_new(argile_syn_param_t *, argile_list_t *);
/** :argile_call_param_new <syn param synparam> <list of (match) matches>: -> (argile) call param **/
void argile_call_param_del(argile_call_param_t *);
/** :argile_call_param_del <call param cp>: -> nothing **/
argile_call_list_t * argile_call_list_new(argile_list_t *, argile_list_t *, argile_list_t *, argile_list_t *);
/** :argile_call_list_new <list of (int) params> <list of (int) options> <list of (int) enums> <list of (int) lists>: -> (argile) call list **/
void argile_call_list_del(argile_call_list_t *);
/** :argile_call_list_del <call list cl>: -> nothing **/
void argile_call_string(argile_call_t *, int, argile_buff_t *);
/** :argile_call_string <call> <int indent> <buff buf>: -> nothing **/
void argile_call_find_all_path(argile_call_t *);
/** :argile_call_find_all_path <call>: -> nothing **/
void argile_call_find_path(argile_call_t *);
/** :argile_call_find_path <call>: -> nothing **/
void argile_call_unfind_path(argile_call_t *);
/** :argile_call_unfind_path <call>: -> nothing **/
void argile_call_setup(argile_call_t *, argile_code_t *, argile_call_t *);
/** :argile_call_setup <call> <argile code code> <call owner>: -> nothing **/
int argile_call_compile_as(argile_call_t *, argile_type_t);
/** :argile_call_compile_as <call> <argile type type>: -> int **/
void argile_call_compile_binds(argile_call_t *);
/** :argile_call_compile_binds <call>: -> nothing **/
int argile_call_compile_subcalls(argile_call_t *);
/** :argile_call_compile_subcalls <call>: -> int **/
void argile_call_uncompile_subcalls(argile_call_t *, int);
/** :argile_call_uncompile_subcalls <call> <int undo_implicits>: -> nothing **/
int argile_call_compile_syntaxes(argile_call_t *);
/** :argile_call_compile_syntaxes <call>: -> int **/
int argile_call_compile_subcodes(argile_call_t *);
/** :argile_call_compile_subcodes <call>: -> int **/
argile_call_t * argile_call_make_implicit(argile_call_t *, argile_def_t *, argile_list_t *, argile_list_t *);
/** :argile_call_make_implicit <call> <def> <list of (match) head> <list of (match) tail>: -> (argile) call **/
void argile_call_undo_implicit(argile_call_t *, argile_call_t *, argile_list_t *);
/** :argile_call_undo_implicit <call> <call sub> <list of (match) matches>: -> nothing **/
argile_type_t argile_call_get_type(argile_call_t *);
/** :argile_call_get_type <call>: -> argile type **/
int argile_call_reject(argile_call_t *);
/** :argile_call_reject <call>: -> int **/
int argile_call_add_reject(argile_call_t *, char *);
/** :argile_call_add_reject <call> <text reason>: -> int **/
void argile_call_take_rejects(argile_call_t *, argile_call_t *);
/** :argile_call_take_rejects <call dst> <call src>: -> nothing **/
void argile_forget_rejects(argile_call_t *);
/** :argile_forget_rejects <call>: -> nothing **/
void argile_call_mismatch(argile_call_t *, argile_type_t, argile_type_t, char *);
/** :argile_call_mismatch <call> <argile type expected> <argile type got> <text error>: -> nothing **/
int argile_call_need_indent(argile_call_t *);
/** :argile_call_need_indent <call>: -> int **/
int argile_call_need_return(argile_call_t *);
/** :argile_call_need_return <call>: -> int **/
void argile_call_gencode(argile_call_t *, int);
/** :argile_call_gencode <call> <int returned>: -> nothing **/
void argile_call_param_gencode(argile_call_param_t *, argile_call_t *);
/** :argile_call_param_gencode <call param param> <call from>: -> nothing **/
void argile_call_gen_ref(argile_call_t *);
/** :argile_call_gen_ref <call>: -> nothing **/
void argile_call_gen_line(argile_call_t *);
/** :argile_call_gen_line <call>: -> nothing **/
argile_type_t argile_call_eval_type(argile_call_t *);
/** :argile_call_eval_type <call>: -> argile type **/
unsigned char argile_call_find_autoparams(argile_call_t *);
/** :argile_call_find_autoparams <call>: -> bool **/

#endif /* _call_HEADER__device_2052_inode_4268265_ */
