// generated by: arc -xuNP -A ./../argrt -M -o std_typeparam.c -H std_typeparam.h -m std_typeparam.argl.tmp std_typeparam.arg 
#include "std_typeparam.h"

static argile_match_t * _get_param(argile_call_t *, argile_syn_param_t * *);
/** :_get_param <call> <(syn param) & param_return>: -> (argile) match **/
static argile_syn_param_t * _find_param(argile_shovel_t *, char *, argile_type_t);
/** :_find_param <shovel sh> <text name> <argile type type>: -> (argile) syn param **/

int argmod_typeparam_defmaker = 1;
char( argmod_typeparam_doc[]) = "Get a parameter that generated the C-type of the parameter of type anything,\nby name or by type; it corresponds to a parameter in the syntax of the type\ngenerating macro.\nSyntax requirements:\n  :<any> { <word> | <type> }:\n";

argile_type_t argmod_typeparam_gettype(argile_call_t * p_argile_call)
/** :argmod_typeparam_gettype <call>: -> argile type **/
{
  argile_syn_param_t * sp = ((argile_syn_param_t *)0);

  _get_param(p_argile_call, &sp);
  if ((sp)) {
    return (sp)->type;
  } //;
  return ARGILE_TYPE_NOTHING;
}

argile_type_t argmod_typeparam_evaltype(argile_call_t * p_argile_call_2)
/** :argmod_typeparam_evaltype <call>: -> argile type **/
{
  argile_match_t * m = ((argile_match_t *)0);

  if (((m = _get_param(p_argile_call_2, ((argile_syn_param_t * *)0))))) {
    return argile_match_eval_type(m);
  } //;
  return ARGILE_TYPE_ANYTHING;
}

int argmod_typeparam_reject(argile_call_t * p_argile_call_3)
/** :argmod_typeparam_reject <call>: -> int **/
{
  argile_syn_param_t * sp = ((argile_syn_param_t *)0);

  _get_param(p_argile_call_3, &sp);
  if ((sp == NULL)) {
    return argile_call_add_reject(p_argile_call_3, "std/typeparam: ""no such type parameter");
  } //;
  return 0;
}

void argmod_typeparam_gencode(argile_call_t * p_argile_call_4)
/** :argmod_typeparam_gencode <call>: -> nothing **/
{
  argile_match_t * m = ((argile_match_t *)0);

  if (((m = _get_param(p_argile_call_4, ((argile_syn_param_t * *)0))))) {
    argile_match_gencode(m);
  } //;
}

static argile_match_t * _get_param(argile_call_t * p_argile_call_5, argile_syn_param_t * * param_return)
/** :_get_param <call> <(syn param) & param_return>: -> (argile) match **/
{
  argile_type_t type;
  char * name = (char *)0;
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  argile_match_t * m = ((argile_match_t *)0);

  type = (argile_type_t)ARGILE_TYPE_NOTHING;
  sh = argile_shovel_new(p_argile_call_5);
  m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_WORD, (char *)0);
  if ((m)) {
    name = argile_match_eval_word(m);
  } //;
  if (((NULL == name) && (m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0)))) {
    type = argile_match_eval_type(m);
  } //;
  if ((m)) {
    m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_ANYTHING, (char *)0);
  } //;
  argile_shovel_del(sh);
  if ((m)) {
    m = argile_match_terminal(m);
  } //;
  if (((m) && ((m)->type == ARGILE_MATCH_SUBCALL))) {
    argile_type_t t;
    argile_type_info_t * i = ((argile_type_info_t *)0);

    t = argile_call_get_type(((m)->value).call);
    i = argile_type_get_info(t);
    if ((i)) {
      argile_call_t * g = ((argile_call_t *)0);

      if ((((i)->ttype == ARGILE_TYPE_KIND_CTYPE) && ((g = (((i)->tval).t_ctype).generator)))) {
        argile_syn_param_t * sp = ((argile_syn_param_t *)0);

        sh = argile_shovel_new(g);
        sp = _find_param(sh, name, type);
        m = argile_shovel_digparamatch(sh, sp);
        argile_shovel_del(sh);
        if (!((&*param_return == NULL))) {
          *param_return = sp;
        } //;
        return m;
      } //;
    } //;
  } //;
  if (!((&*param_return == NULL))) {
    *param_return = ((argile_syn_param_t *)0);
  } //;
  return ((argile_match_t *)0);
}

static argile_syn_param_t * _find_param(argile_shovel_t * sh, char * name, argile_type_t type)
/** :_find_param <shovel sh> <text name> <argile type type>: -> (argile) syn param **/
{
  argile_list_t * lsp;

  lsp = (sh)->syn_params;
  for (; (lsp); lsp = ((argile_list_t *)lsp)->next) {
    argile_syn_param_t * sp = ((argile_syn_param_t *)0);

    sp = *((argile_syn_param_t * *)&((argile_list_t *)lsp)->data);
    if ((name)) {
      if ((((sp)->name) && (strcmp((sp)->name, name) == 0))) {
        return sp;
      } //;
    } //;
    else if (((sp)->type == type)) {
      return sp;
    } //;
  };
  return ((argile_syn_param_t *)0);
}

